Subject: Re: linux-next: build failure after merge of the rust tree

From: Stephen Rothwell <[email-masked]>
Date: Wed, 29 Sep 2021 09:37:58 +1000

Hi All,

On Tue, 28 Sep 2021 15:52:47 +1000 Stephen Rothwell <[email-masked]> wrote:
>
> On Tue, 28 Sep 2021 05:18:49 +0100 Gary Guo <[email-masked]> wrote:
> >
> > On Tue, 28 Sep 2021 14:09:32 +1000
> > Stephen Rothwell <[email-masked]> wrote:
> >   
> > > Hi all,
> > > 
> > > After merging the rust tree, today's linux-next build (x86_64
> > > allmodconfig) failed like this:
> > > 
> > > scripts/kconfig/confdata.c: In function 'rustc_cfg_print_symbol':
> > > scripts/kconfig/confdata.c:669:9: warning: implicit declaration of
> > > function 'sym_escape_string_value'; did you mean
> > > 'sym_set_string_value'? [-Wimplicit-function-declaration] 669 |   str
> > > = sym_escape_string_value(value); |         ^~~~~~~~~~~~~~~~~~~~~~~ |
> > >         sym_set_string_value scripts/kconfig/confdata.c:669:7:
> > > warning: assignment to 'const char *' from 'int' makes pointer from
> > > integer without a cast [-Wint-conversion] 669 |   str =
> > > sym_escape_string_value(value); |       ^ /usr/bin/ld:
> > > scripts/kconfig/confdata.o: in function `rustc_cfg_print_symbol':
> > > confdata.c:(.text+0x738): undefined reference to
> > > `sym_escape_string_value'
> > > 
> > > Caused by commit
> > > 
> > >   dc08d49444e9 ("Kbuild: add Rust support")
> > > 
> > > interacting with commit
> > > 
> > >   420a2bdbead2 ("kconfig: Refactor sym_escape_string_value")
> > > 
> > > from the kbuild tree.
> > > 
> > > I applied the following patch, but it doesn't seem quite right.    
> > 
> > That's indeed incorrect, if we have `CONFIG_FOO=bar` then sym here is
> > `FOO` and value is `bar`. I think to resolve the conflict, 420a2bdbead2
> > would have to be reverted.  
> 
> OK, I have done that for today.  (I needed to revert
> 16f3610168218ed5e2eafa6978bb7f10c175c7a9 as well).

Today, I have applied the following patch to the kbuild tree.
Masahiro, would you consider adding this to the kbuild tree itself?  Or
is there a betters solution for what the rust tree wants to do?

From: Stephen Rothwell <[email-masked]>
Date: Wed, 29 Sep 2021 09:30:02 +1000
Subject: [PATCH] kconfig: restore sym_escape_string_value()

This function will be used by the rust tree.

Cc: Miguel Ojeda <[email-masked]>
Cc: Gary Guo <[email-masked]>
Cc: Richard Weinberger <[email-masked]>
Signed-off-by: Stephen Rothwell <[email-masked]>
---
 scripts/kconfig/lkc_proto.h |  1 +
 scripts/kconfig/symbol.c    | 11 +++++++----
 2 files changed, 8 insertions(+), 4 deletions(-)

diff --git a/scripts/kconfig/lkc_proto.h b/scripts/kconfig/lkc_proto.h
index 7ce4b666bba8..62e0ed773f41 100644
--- a/scripts/kconfig/lkc_proto.h
+++ b/scripts/kconfig/lkc_proto.h
@@ -18,6 +18,7 @@ extern struct symbol * symbol_hash[SYMBOL_HASHSIZE];
 
 struct symbol * sym_lookup(const char *name, int flags);
 struct symbol * sym_find(const char *name);
+char *sym_escape_string_value(const char *in);
 char *sym_escape_string(struct symbol *sym);
 struct symbol ** sym_re_search(const char *pattern);
 const char * sym_type_name(enum symbol_type type);
diff --git a/scripts/kconfig/symbol.c b/scripts/kconfig/symbol.c
index 2dc251b0930e..ca115569d497 100644
--- a/scripts/kconfig/symbol.c
+++ b/scripts/kconfig/symbol.c
@@ -872,15 +872,13 @@ struct symbol *sym_find(const char *name)
 }
 
 /* The returned pointer must be freed on the caller side */
-char *sym_escape_string(struct symbol *sym)
+char *sym_escape_string_value(const char *in)
 {
-	const char *in, *p;
+	const char *p;
 	size_t reslen;
 	char *res;
 	size_t l;
 
-	in = sym_get_string_value(sym);
-
 	reslen = strlen(in) + strlen("\"\"") + 1;
 
 	p = in;
@@ -917,6 +915,11 @@ char *sym_escape_string(struct symbol *sym)
 	return res;
 }
 
+char *sym_escape_string(struct symbol *sym)
+{
+	return sym_escape_string_value(sym_get_string_value(sym));
+}
+
 struct sym_match {
 	struct symbol	*sym;
 	off_t		so, eo;
-- 
2.33.0

-- 
Cheers,
Stephen Rothwell